// AppTechObjectPool.hxx
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(APPTECHOBJECTPOOL_HXX__INCLUDED) // {
#define APPTECHOBJECTPOOL_HXX__INCLUDED

#include "Config.hxx"
#include "ObjectPool.hxx"
#include "AppTech.hxx"
#include "AppTechFlammableBuilding.hxx"

namespace Rescue
{
    /////////////////////////////////////////////////////////////////////////
    // AppTechObjectPool

    class Input;
    class Output;
    /** ֥Ȥν */
    class AppTechObjectPool : public ObjectPool
    {
    private:
        
    protected:
#if 0
        Objects m_unregisterdBuilding;
#endif
    public:
        virtual ~AppTechObjectPool();
        AppTechObjectPool(const Config&);
        AppTechObjectPool();

        virtual Object* newObject(TypeId type);

#if 0
        /**
        * ֥ȤϿ롣
        * @param    newObject
        *               Ͽ륪֥ȡΥ֥Ȥ      
        *               ObjectPool ˤä delete 롣id ѤߤǤ뤳ȡ
        */
        virtual void add(Object* newObject);
#endif

        void dataread();
        void mkdat(S32 time);
        
        void fireInit(S32 time);
        void fireUpdate(S32 time);
        void step(S32 time);
    public:

  // ƥѥ᡼
        class fprmt {
        public:
            double  tsl[3]; // Ƥ֡¤ɲСѲС
            double  ts1[3]; // бФ֡¤ɲСѲС
            double  prc;    // ޤǤλΨ  0.4
            double  pra;    // åؿη8
            double  prv1;   // ®-0.4
            double  cww[3]; // ʪ¤̥
            double  sta1;   // ࣱ  100.0m2
            double  stal;   // پ  100.0m2
            double  stf1;   // ࣱƷʪ⤵  3m
            double  stqw;   // кҲٽ  120.0kg/m2
            double  sts;    // ห̤١2.94
            double  std;    // Υ1.0m
            double  ctw[3]; // ¤ʪд(ѱƱƶ,
                    //                    ñֱ̻Ʊƶ,
                    //                    ñֺ̻Ʊƶ)
            S32 dt; // tֹ()
            S32 itoukai;// ݲflagʣθ롡θʤ

            fprmt() {
            }
            fprmt(const Config& cf){
                tsl[0] = cf.TSL1(); // Ƥ֡¤ɲСѲС
                tsl[1] = cf.TSL2(); // Ƥ֡¤ɲСѲС
                tsl[2] = cf.TSL3(); // Ƥ֡¤ɲСѲС
                ts1[0] = cf.TS11(); // бФ֡¤ɲСѲС
                ts1[1] = cf.TS12(); // бФ֡¤ɲСѲС
                ts1[2] = cf.TS13(); // бФ֡¤ɲСѲС
                prc = cf.PRC();     // ޤǤλΨ  0.4
                pra = cf.PRA();     // åؿη8
                prv1 = cf.PRV1();   // ®-0.4
                cww[0] = cf.CWW1(); // ʪ¤̥
                cww[1] = cf.CWW2(); // ʪ¤̥
                cww[2] = cf.CWW3(); // ʪ¤̥
                sta1 = cf.STA1();   // ࣱ  100.0m2
                stal = cf.STAL();   // پ  100.0m2
                stf1 = cf.STF1();   // ࣱƷʪ⤵  3m
                stqw = cf.STQW();   // кҲٽ  120.0kg/m2
                sts = cf.STS();     // ห̤١2.94
                std = cf.STD();     // Υ1.0m
                ctw[0] = cf.CTW1(); // ¤ʪд(ѱƱƶ,
                ctw[1] = cf.CTW2(); // ¤ʪд(ѱƱƶ,
                ctw[2] = cf.CTW3(); // ¤ʪд(ѱƱƶ,
                            //                    ñֱ̻Ʊƶ,
                            //                    ñֺ̻Ʊƶ)
                dt = cf.DT();   // tֹ()
                //S32   itoukai;// ݲflagʣθ롡θ               
            }
        };
        fprmt para;

        class tutu_n {
        public:
            // target building
            AppTechFlammableBuilding* building;
            S32 num; // XXX: target_buildin_id 

            S32 direction;
            XY xy;
            double quantity;
            S32 ewsn;
            
            tutu_n(AppTechFlammableBuilding* fb, S32 dir, S32 x, S32 y, S32 quantity, bool round_quantity) {
                building = fb;
                direction = dir;
                xy = XY(x, y);
                if (round_quantity)
                    this->quantity = quantity / 1000; // 1/1000 m3/min -> m3/min 
                else
                    this->quantity = quantity / 1000.0; // 1/1000 m3/min -> m3/min 
            }
        };
        std::vector<tutu_n> in_tutu;
#if 1
        std::vector<AppTechFlammableBuilding*> fb_v;
#else
        AppTechFlammableBuilding* tikudat[1024];
        int tikudat_size;
#endif

        class dummy_array {
        public:
            int size() { return objpool->fb_v.size(); }
            AppTechObjectPool* objpool;
            dummy_array(AppTechObjectPool* op = NULL){
                objpool = op;
            }
        };

        class dummy_tikudat :public dummy_array{
        public:
            dummy_tikudat(AppTechObjectPool* op = NULL) :dummy_array(op) {}
            AppTechFlammableBuilding& operator[](int i) { return *(objpool->fb_v[i]); }
        } tikudat;

        class dummy_rindat :public dummy_array{
        public:
            dummy_rindat(AppTechObjectPool* op = NULL) :dummy_array(op) {}
            AppTechFlammableBuilding::rinsetu_v& operator[](int i) { return (*(objpool->fb_v[i])).nrinsetu; }
        } rindat;

        class dummy_fire :public dummy_array{
        public:
            dummy_fire(AppTechObjectPool* op = NULL) :dummy_array(op) {}
            AppTechFlammableBuilding::ensho& operator[](int i) { return (*(objpool->fb_v[i])).fire; }
        } fire;

        class dummy_now :public dummy_array{
        public:
            dummy_now(AppTechObjectPool* op = NULL) :dummy_array(op) {}
            AppTechFlammableBuilding::tmp& operator[](int i) { return (*(objpool->fb_v[i])).now; }
        } now;

        class dummy_enslog :public dummy_array{
        public:
            dummy_enslog(AppTechObjectPool* op = NULL) :dummy_array(op) {}
            AppTechFlammableBuilding::log& operator[](int i) { return (*(objpool->fb_v[i])).fire_log; }
        } enslog;

        int hensu_MP_nkk; // XXX:ʪ

//      int icnt;
        int icall;
        int tnow;
//      int icall_tmp;
//      int tnow_tmp;

        class ks {
        public:
            int at_ks_ndw;      //!()yθȾײˡ
            double at_ks_wvv;   //!®
            ks(){
                at_ks_ndw = 0;
                at_ks_wvv = 0;
            }
        };
        ks kisyo;

        void calc(const S32 time);
    private:
        AppTechObjectPool(const AppTechObjectPool& source);
        AppTechObjectPool& operator= (const AppTechObjectPool& rhs);
        bool operator== (const AppTechObjectPool& rhs) const;
    };
    
    /////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#ifdef NDEBUG
#  include "AppTechObjectPool.inl"
#endif

#endif // } !defined(APPTECHOBJECTPOOL_HXX__INCLUDED)
